#pragma pack(2)
#include <Common.h>
#include <System/SysAll.h>
#include <UI/UIAll.h>
#include <System/SysEvtMgr.h>
#include <System/KeyMgr.h>

#include "concorde.h"

/* decode routine and imports/exports */
int decode();
short int *chb, *qwkd, *tokbuf;
unsigned long *lcb, *ldb, *chix, *book;
unsigned char *lhb, *outb, *qwkb;
int chap;
VoidHand qwkch;
extern int verse, vlist[];

/* handles for above pointers */
static VoidHand ooutb, qwkdh, bookh, chixh, chbh, lhbh, lcbh, ldbh;

static struct {
  int font;
  UInt text;
} cappprefs;

static struct cprefs {
  int prfbook[30], prfchap[30], prfscrl[30];
} *cordprefs, *bx;

#define MAXTEXTS 20
static VoidHand pptr;
static UInt tcard[MAXTEXTS];
static LocalID texts[MAXTEXTS];
static UInt ntexts, curtext;
static DmOpenRef textdb;

static char textname[32];
static FieldPtr textfield;
static ListPtr booklist, chaplist, verslist;
static FormPtr form;
static ScrollBarPtr bar;

static int cbook;
static int maxbook;
static char *bstrs[100];
static int chmark, nchap;
static int ibook, ichap, iscroll;

/* chapter/verse picklist */
static char chstrb[400];
static char *chstr[200];

static void fixvers()
{
  Word sp, thp;

  sp = FldGetScrollPosition(textfield);
  for (thp = 1; thp < verse; thp++)
    if (vlist[thp] > sp)
      break;
  thp--;
  LstSetTopItem(verslist, thp);
  LstSetSelection(verslist, thp);
  CtlSetLabel(FrmGetObjectPtr(form, FrmGetObjectIndex(form, tvers)), chstr[thp]);
}

/* correct the scrollbar */
static void fixscrl()
{
  Word sp, thp, fhp;

  FldGetScrollValues(textfield, &sp, &thp, &fhp);
  SclSetScrollBar(bar, sp, 0, thp > fhp ? thp - fhp : sp, fhp - 1);
}

#define MAXBOOK 100
UInt bookrsc[MAXBOOK];

/* process book and chapter change and call decode */
static void gettext(int disp)
{
  long int i, j;

  if (ibook < 0)
    ibook = 0;
  else if (ibook > maxbook)
    ibook = maxbook;

  if (disp)
    FldSetTextHandle(textfield, NULL);

  if (ibook != cbook) {
    cbook = ibook;
    if (bookh) {
      MemHandleUnlock(bookh);
      DmReleaseResource(bookh);
    }
    bookh = DmGet1Resource('CORD', bookrsc[ibook]);
    if (!bookh)
      return;
    book = MemHandleLock(bookh);
    ichap = 1;

    i = bookrsc[ibook] - 0x2001 + 1;
    j = 0;
    while (i--)
      while (chix[++j]);
    chmark = j;

    i = j;
    while (chix[++i]);
    nchap = i - j - 2;

    if (ichap) {
      i = ibook - 5;
      if (i + 11 >= maxbook)
        i = maxbook - 11;
      if (i < 0)
        i = 0;
      LstSetSelection(booklist, ibook);
      LstSetTopItem(booklist, i);
      CtlSetLabel(FrmGetObjectPtr(form, FrmGetObjectIndex(form, tbook)), bstrs[ibook]);
    }
    LstSetListChoices(chaplist, chstr, nchap);
  }
  if (ichap > nchap)
    ichap = nchap;
  if (ichap < disp)
    ichap = 1;

  if (disp) {
    i = ichap - 6;
    if (i + 10 >= nchap)
      i = nchap - 10;
    if (i < 0)
      i = 0;
    LstSetTopItem(chaplist, i);
    LstSetSelection(chaplist, ichap - 1);
    CtlSetLabel(FrmGetObjectPtr(form, FrmGetObjectIndex(form, tchap)), chstr[ichap - 1]);
  }
  i = chix[chmark + ichap];
  j = chix[chmark + ichap + 1];

  chap = ichap;
  outb = MemHandleLock(ooutb);

  if ((!i && disp) || !j || decode(i, j)) {
    MemHandleUnlock(ooutb);
    ichap = 0;
    return;
  }
  MemHandleUnlock(ooutb);
  if (disp != 1)
    return;

  LstSetListChoices(verslist, chstr, verse - 1);

  FldSetTextHandle(textfield, (Handle) ooutb);
  FldSetScrollPosition(textfield, iscroll);
  fixvers();
  iscroll = 0;
  FrmDrawForm(form);
  fixscrl();
}

/*****************/
/* Find routines */
/*****************/

char find[256];
Word foundat;
int bmtab[256];
int findlen;

/* Boyer Moore (like) search setup */
static void bmsetup()
{
  int i;

  findlen = StrLen(find);
  for (i = 0; i < 256; i++)
    bmtab[i] = findlen;
  for (i = 0; i < findlen; i++) {
    bmtab[find[i]] = -i;
    bmtab[find[i] ^ 0x20] = -i;
  }
}

extern int findstrinstr(char *search);

static int lastbook, lastchap, lastscrl;

/* handle find modal dialog */
int dofinddlg()
{
  FormPtr ff;
  FieldPtr textf;
  VoidHand thand;
  int k;

  if (!(ff = FrmInitForm(ffind)))
    return 0;

  thand = MemHandleNew(256);
  StrCopy(MemHandleLock(thand), find);

  MemHandleUnlock(thand);
  textf = FrmGetObjectPtr(ff, FrmGetObjectIndex(ff, ftext));
  FldSetTextHandle(textf, (Handle) thand);
  FrmSetFocus(ff, FrmGetObjectIndex(ff, ftext));

  k = FrmDoDialog(ff);

  if (k == fcanc) {
    FrmDeleteForm(ff);
    return 0;
  }

  lastchap = 0;
  textf = FrmGetObjectPtr(ff, FrmGetObjectIndex(ff, ftext));
  thand = (VoidHand) FldGetTextHandle(textf);

  StrCopy(find, MemHandleLock(thand));

  MemHandleUnlock(thand);
  FrmDeleteForm(ff);
  bmsetup();

  return 1;
}

/* scan from current (or last found) forward for string */
static int scanbooks(int donext)
{
  int savbook = ibook, savchap = ichap;
  int savscrl, k, svs;
  char *cp;

  switch (donext) {
  case 0:
    if (!dofinddlg())
      return 0;
    break;
  case 1:
    if (!lastchap)
      return 0;
    break;
  case 2:
    lastchap = 0;
    break;
  }

  savscrl = FldGetScrollPosition(textfield);  /* save current if not found */

  if (!lastchap) {              /* check rest of current chapter */
    cp = MemHandleLock(ooutb);
    svs = savscrl + findlen + 100;
    k = findstrinstr(&cp[svs]);
    MemHandleUnlock(ooutb);
    if (k) {
      svs += foundat;
      FldSetScrollPosition(textfield, svs);

      fixscrl();
      fixvers();
      FldSetSelection(textfield, svs, svs + findlen);
      lastbook = ibook, lastchap = ichap, lastscrl = svs + findlen;
      return 1;
    }
    ichap++;
  } else {                      /* fnext - start from after last found  */
    if (ibook != lastbook) {
      ibook = lastbook;
      gettext(0);
      ichap = 0;
    }
    if (ichap != lastchap) {
      ichap = lastchap;
      gettext(2);
    }
    cp = MemHandleLock(ooutb);
    k = findstrinstr(&cp[lastscrl]);
    MemHandleUnlock(ooutb);
    if (k) {
      lastscrl += foundat;

      iscroll = lastscrl;
      gettext(1);
      FldSetSelection(textfield, lastscrl, lastscrl + findlen);

      lastscrl += findlen;
      return 1;
    }
    ichap++;
  }

  for (; ibook <= maxbook; ibook++) {  /* scan through books and chapters */
    EvtResetAutoOffTimer();
    for (; ichap <= nchap; ichap++) {
      gettext(2);

      k = findstrinstr(MemHandleLock(ooutb));
      MemHandleUnlock(ooutb);
      if (k) {                  /* found - put up text field */
        iscroll = foundat;
        gettext(1);
        FldSetSelection(textfield, foundat, foundat + findlen);

        lastbook = ibook, lastchap = ichap, lastscrl = foundat + findlen;
        return 1;
      }
      for (;;) {                /* limited event handler during search */
        EventType event;
        short err;

        EvtGetEvent(&event, 0);
        if (event.eType == nilEvent)
          break;
        if (event.eType == penDownEvent) {
          ibook = maxbook + 1;  /* exit out of fors */
          ichap = nchap + 1;
          break;
        }
        if (SysHandleEvent(&event))
          continue;
        if (MenuHandleEvent((void *) 0, &event, &err))
          continue;
        if (FrmHandleEvent(form, &event))
          continue;
      }
    }
    ichap = 1;
  }
  /* not found - rewind to where we started */
  ibook = savbook;
  gettext(0);
  ichap = savchap;
  iscroll = savscrl;
  gettext(1);
  return 0;
}

/********************/

/* set up book list - initially or when new text selected */
static void Bsetup()
{
  VoidPtr boutb = MemPtrNew(2048);
  int xbook;
  RectangleType title =
  {
    {0, 0},
    {160, 13}};

  FrmSetTitle(form, textname);
  WinEraseRectangle(&title, 0);

  chmark = 0;
  ibook = 0;
  for (xbook = 0; xbook < MAXBOOK; xbook++) {
    if (bookh) {
      MemHandleUnlock(bookh);
      DmReleaseResource(bookh);
    }
    if (!(bookh = DmGet1Resource('CORD', xbook + 0x2001)))
      continue;

    bookrsc[ibook] = xbook + 0x2001;

    book = MemHandleLock(bookh);
    ichap = 0;
    maxbook = ibook;
    cbook = ibook;
    gettext(0);
    MemHandleUnlock(bookh);
    bookh = 0;

    /* SysFormPointerArrayToStrings(boutb-orig, ibook); */
    bstrs[ibook] = boutb;
    StrCopy(boutb, MemHandleLock(ooutb));  /* save title */
    MemHandleUnlock(ooutb);
    boutb += StrLen(boutb) + 1;
    ibook++;
  }

  cbook = 9999;
  ibook = cordprefs->prfbook[0];
  if( ibook > maxbook ) /* someone deleted something out from under me */
    ibook = 0, ichap = 1; iscroll = 0;
  LstSetListChoices(booklist, bstrs, maxbook + 1);

  gettext(2);
  ichap = cordprefs->prfchap[0];
  iscroll = cordprefs->prfscrl[0];

  gettext(1);
  fixscrl();
  fixvers();
}

/********************/
/* open/close db */
/********************/

static void opendb()
{
  int i;

  lastchap = 0;

  qwkch = 0;
  if (curtext >= ntexts)
    curtext = 0;

  DmDatabaseInfo(tcard[curtext], texts[curtext], textname, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
  textdb = DmOpenDatabase(tcard[curtext], texts[curtext], dmModeReadWrite);
  cappprefs.text = curtext;

  chbh = DmGet1Resource('CORD', 0x1800);
  chb = MemHandleLock(chbh);
  lhbh = DmGet1Resource('CORD', 0x1801);
  lhb = MemHandleLock(lhbh);
  ldbh = DmGet1Resource('CORD', 0x1802);
  ldb = MemHandleLock(ldbh);
  lcbh = DmGet1Resource('CORD', 0x1803);
  lcb = MemHandleLock(lcbh);
  if ((qwkch = DmGet1Resource('CORD', 0x1901))) {
    qwkb = MemHandleLock(qwkch);
    qwkdh = DmGet1Resource('CORD', 0x1900);
    qwkd = MemHandleLock(qwkdh);
  }
  chixh = DmGet1Resource('CORD', 0x1804);
  chix = MemHandleLock(chixh);

  if ((pptr = DmGet1Resource('CORD', 0)) &&
      MemHandleSize(pptr) == sizeof(struct cprefs)) {
    bx = MemHandleLock(pptr);
    MemMove(cordprefs,bx,sizeof(struct cprefs));

    return;
  }
  if (!pptr)
    pptr = DmNewResource(textdb, 'CORD', 0, sizeof(struct cprefs));
  else
    DmResizeResource(pptr, sizeof(struct cprefs));

  bx = MemHandleLock(pptr);
  for (i = 0; i < 30; i++) {
    cordprefs->prfbook[i] = 0;
    cordprefs->prfchap[i] = 1;
    cordprefs->prfscrl[i] = 0;
  }
  DmWrite(bx, 0, cordprefs, sizeof(struct cprefs));

}

static void closedb()
{
  if (bookh) {
    MemHandleUnlock(bookh);
    DmReleaseResource(bookh);
    bookh = NULL;
  }
  if (chixh) {
    MemHandleUnlock(chixh);
    DmReleaseResource(chixh);
  }
  if (qwkch) {
    MemHandleUnlock(qwkdh);
    DmReleaseResource(qwkdh);
    MemHandleUnlock(qwkch);
    DmReleaseResource(qwkch);
  }
  MemHandleUnlock(lcbh);
  DmReleaseResource(lcbh);
  MemHandleUnlock(ldbh);
  DmReleaseResource(ldbh);
  MemHandleUnlock(lhbh);
  DmReleaseResource(lhbh);
  MemHandleUnlock(chbh);
  DmReleaseResource(chbh);

  cordprefs->prfbook[0] = ibook;
  cordprefs->prfchap[0] = ichap;
  cordprefs->prfscrl[0] = FldGetScrollPosition(textfield);

  ibook = 0, ichap = 1, iscroll = 0;

  DmWrite(bx, 0, cordprefs, sizeof(struct cprefs));
  MemHandleUnlock(pptr);
  DmReleaseResource(pptr);

  DmCloseDatabase(textdb);
}

/* create list of texts */
static int getdblist()
{
  DmSearchStateType dss;

  ntexts = 0;
  if (DmGetNextDatabaseByTypeCreator(true, &dss, 'DATA', 'CORD', false, &tcard[ntexts], &texts[ntexts]))
    return 1;
  ntexts++;
  while (ntexts < MAXTEXTS && !DmGetNextDatabaseByTypeCreator(false, &dss, 'DATA', 'CORD', false, &tcard[ntexts], &texts[ntexts]))
    ntexts++;
  return 0;
}

/**********************/
static int fontid[4] =
{0, 1, 2, 7};

/* main event handler */
static Boolean doit(EventPtr event)
{
  int handled = 0;
  Short v, mn, mx, ps;
  DWord j;

  switch (event->eType) {
  case frmOpenEvent:

    if (FrmGetActiveFormID() != Fconcorde) {
      FormPtr form1;
      if (!(form1 = FrmGetActiveForm()))
        return 1;
      return (FrmHandleEvent(form1, event));
    }
    form = FrmGetActiveForm();
    chaplist = FrmGetObjectPtr(form, FrmGetObjectIndex(form, pchap));
    verslist = FrmGetObjectPtr(form, FrmGetObjectIndex(form, pvers));
    booklist = FrmGetObjectPtr(form, FrmGetObjectIndex(form, pbook));

    textfield = FrmGetObjectPtr(form, FrmGetObjectIndex(form, outtext));
    bar = FrmGetObjectPtr(form, FrmGetObjectIndex(form, scrl));
    FldSetFont(textfield, fontid[cappprefs.font]);
    Bsetup();
    handled = 1;
    break;

  case keyDownEvent:
    {
      DWord k;
      Word flns;

      k = event->data.keyDown.chr;

      if (k == pageUpChr) {
        if (!FldGetScrollPosition(textfield)) {
          ichap--;
          gettext(2);
          outb = MemHandleLock(ooutb);
          iscroll = StrLen(outb) - 100;
          MemHandleUnlock(ooutb);
          gettext(1);
        } else {
          FldGetScrollValues(textfield, NULL, NULL, &flns);
          FldScrollField(textfield, flns / 2, up);
        }

        fixscrl();
        fixvers();
        handled = 1;

      } else if (k == pageDownChr) {
        j = FldGetScrollPosition(textfield);
        FldGetScrollValues(textfield, NULL, NULL, &flns);
        FldScrollField(textfield, flns / 2, down);
        if (j == FldGetScrollPosition(textfield)) {  /* if we didn't move, we're at bottom */
          ichap++;
          gettext(1);
        }
        fixscrl();
        fixvers();
        handled = 1;

      } else if (k >= 'a' && k <= 'z') {
        k -= 'a' - 1;
        ibook = cordprefs->prfbook[k];
        gettext(2);
        ichap = cordprefs->prfchap[k];
        iscroll = cordprefs->prfscrl[k];
        gettext(1);
        handled = 1;

      } else if (k >= 'A' && k <= 'Z') {
        k -= 'A' - 1;
	cordprefs->prfbook[k] = ibook;
	cordprefs->prfchap[k] = ichap;
	cordprefs->prfscrl[k] = FldGetScrollPosition(textfield);
        handled = 1;
      }
    }
    break;
  case sclExitEvent:
    SclGetScrollBar(bar, &v, &mn, &mx, &ps);
    outb = MemHandleLock(ooutb);
    j = StrLen(outb) + 8;       /* plus a little to bias toward the bottom */
    MemHandleUnlock(ooutb);
    FldSetScrollPosition(textfield, j * v / (ps + mx));
    fixvers();
    handled = 1;
    break;

  case menuEvent:
    switch (event->data.menu.itemID) {
    case mchgfont:
      cappprefs.font = (cappprefs.font + 1) & 3;
      if (cappprefs.font == 3) {
        DWord d;
        FtrGet(sysFtrCreator, sysFtrNumROMVersion, &d);
        if (sysGetROMVerMajor(d) < 3)
          cappprefs.font = 0;
      }
      FldSetFont(textfield, fontid[cappprefs.font]);
      fixscrl();
      fixvers();
      handled = 1;
      break;
    case mtext:
      MenuEraseStatus(MenuGetActiveMenu());

      {
        FormPtr ff;
        ListPtr tlp;
        char *textlist = MemPtrNew(2048);
        char *tlh[MAXTEXTS];
        char *tp;

        ff = FrmInitForm(Fseltext);

        textlist[0] = 0;
        tp = textlist;
        for (v = 0; v < ntexts; v++) {
          DmDatabaseInfo(tcard[v], texts[v], tp, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0);
          tlh[v] = tp;
          tp += StrLen(tp) + 1;
        }
        tlp = FrmGetObjectPtr(ff, FrmGetObjectIndex(ff, ptext));

        LstSetListChoices(tlp, tlh, ntexts);
        LstSetSelection(tlp, curtext);

        if (fcanc == FrmDoDialog(ff)) {
          MemPtrFree(textlist);
          FrmDeleteForm(ff);
	  handled = 1;
          break;
        }
        curtext = LstGetSelection(tlp);

        LstSetSelection(booklist, 0);
        CtlSetLabel(FrmGetObjectPtr(form, FrmGetObjectIndex(form, tbook)), "");
        closedb();
        MemPtrFree(bstrs[0]);

        opendb();
        Bsetup();

        MemPtrFree(textlist);
        FrmDeleteForm(ff);
      }
      handled = 1;
      break;
    case mdeldb:
      MenuEraseStatus(MenuGetActiveMenu());
      if (FrmAlert(adeltext)) {
        LstSetSelection(booklist, 0);
        CtlSetLabel(FrmGetObjectPtr(form, FrmGetObjectIndex(form, tbook)), "");
        closedb();
        MemPtrFree(bstrs[0]);
        DmDeleteDatabase(tcard[curtext], texts[curtext]);
        curtext = 0;
        if (getdblist()) {
          FrmAlert(anotext);
	  handled = 1;
          break;
        }
        opendb();
        Bsetup();
      }
      handled = 1;
      break;
    case mabout:
      FrmAlert(aabout);
      handled = 1;
      break;
    }
    break;
  case nilEvent:
    handled = 1;
    break;
  case popSelectEvent:
    if (event->data.popSelect.controlID == tvers) {
      FldSetScrollPosition(textfield, vlist[LstGetSelection(verslist)]);
      fixscrl();
      break;
    } else if (event->data.popSelect.selection != event->data.popSelect.priorSelection)
      switch (event->data.popSelect.controlID) {
      case tbook:
        ibook = LstGetSelection(booklist);
        ichap = 1;
        gettext(1);
        break;
      case tchap:
        ichap = 1 + LstGetSelection(chaplist);
        gettext(1);
        break;
      }
    break;
  case ctlSelectEvent:
    switch (event->data.ctlEnter.controlID) {
    case fsearch:
      scanbooks(0);
      handled = 1;
      break;
    case fnext:
      if (find[0])
        scanbooks(1);
      else
        scanbooks(0);
      handled = 1;
      break;
    case ffwd:
      if (find[0])
        scanbooks(2);
      else
        scanbooks(0);
      handled = 1;
      break;
    case ffn:
      {
	/* Lame - should bypass whitespace and be case insensitive */
	char *c = bstrs[maxbook],*d = " FOOTNOTE";
	int i=10;
	while( --i )
	  if (*c++ != *d++ )
	    break;
	if( i ) {
#if 0
  {
    char x[12];
    StrIToA(x, i);
    WinDrawChars(x, StrLen(x), 0, 0);
  }
#endif
	  handled = 1;
	  break;
	}
      }
      if( ibook != maxbook ) {
	lastbook = ibook, lastchap = ichap, lastscrl = FldGetScrollPosition(textfield);
	ibook = maxbook;
	gettext(2);
	ichap = lastbook + 1;
	gettext(1);
	FldSetScrollPosition(textfield, vlist[lastchap - 1]);
	fixscrl();
	fixvers();
      } else {
	ibook = lastbook;
	gettext(0);
	ichap = lastchap;
	iscroll = lastscrl;
	gettext(1);
      }
      handled = 1;
      break;
    }
  case fldEnterEvent:
  case fldHeightChangedEvent:
  case fldChangedEvent:
  case lstEnterEvent:
  case lstSelectEvent:
  case lstExitEvent:
  case penDownEvent:
  case penUpEvent:
  case penMoveEvent:
  case sclEnterEvent:
  case sclRepeatEvent:
    if (form)
      handled = FrmHandleEvent(form, event);
    if (event->screenY < 160)
      handled = 1;
    break;
  case ctlEnterEvent:
  case ctlExitEvent:
  case ctlRepeatEvent:
  case frmUpdateEvent:
  case winEnterEvent:
  case winExitEvent:
    if (form)
      handled = FrmHandleEvent(form, event);
    break;
  }
  return handled;
}

/****************/

DWord PilotMain(Word cmd, Ptr cmdPBP, Word launchFlags)
{
  short err;
  int formID;
  EventType event;
  int i;
  UInt cps;
  ULong appid;
  LocalID lid;

  if (cmd != sysAppLaunchCmdNormalLaunch)
    return 0;

  SysCurAppDatabase(&cps,&lid);
  DmDatabaseInfo(cps,lid,textname,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,&appid);

  find[0] = 0;
  ooutb = MemHandleNew(16384);
  tokbuf = MemPtrNew(8192);
  cps = sizeof(struct cprefs);
  cordprefs = MemPtrNew(cps);
  MemSet(&cappprefs, sizeof(cappprefs), 0);
  cps = sizeof(cappprefs);

  PrefGetAppPreferences(appid, 0, &cappprefs, &cps, true);
  curtext = cappprefs.text;
  if (getdblist()) {
    FrmAlert(anotext);
    return 1;
  }
  opendb();
  FrmGotoForm(Fconcorde);

  /* set numeric picklist */
  for (i = 0; i < 100; i++)
    StrIToA(&chstrb[i * 4], i + 100);
  for (i = 1; i < 10; i++)
    chstr[i - 1] = &chstrb[i * 4 + 2];
  for (i = 10; i < 100; i++)
    chstr[i - 1] = &chstrb[i * 4 + 1];
  for (i = 100; i < 200; i++)
    chstr[i - 1] = &chstrb[(i - 100) * 4];

  form = NULL;
  do {
    EvtGetEvent(&event, evtWaitForever);
    if (SysHandleEvent(&event))
      continue;
    if (MenuHandleEvent((void *) 0, &event, &err))
      continue;
    if (event.eType == frmLoadEvent) {
      formID = event.data.frmLoad.formID;
      form = FrmInitForm(formID);
      FrmSetActiveForm(form);
      switch (formID) {
      case Fconcorde:
        FrmSetEventHandler(form, (FormEventHandlerPtr) doit);
        break;
      }
    }
    if (form)
      FrmDispatchEvent(&event);
  } while (ntexts && event.eType != appStopEvent);

  if (ntexts) {
    closedb();
    FldSetTextHandle(textfield, NULL);
    MemHandleFree(ooutb);
    PrefSetAppPreferences(appid, 0, 1, &cappprefs, sizeof(cappprefs), true);
  }
  return 0;
}
